#A dictionary of Greek phonology
phonology = {'letters': ['α', 'ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'ε', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ο', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ', 'υ', 'ὺ', 'ύ', 'ῦ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'Ὗ', 'ϋ', 'ῢ', 'ΰ', 'ῧ', 'ι', 'ὶ', 'ί', 'ῖ', 'ἰ', 'ἲ', 'ἴ', 'ἶ', 'ἱ', 'ἳ', 'ἵ', 'ἷ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἶ', 'Ἱ', 'Ἳ', 'Ἵ', 'Ἷ', 'ϊ', 'ῒ', 'ΐ', 'ῗ', 'ῥ', 'ρ', 'λ', 'μ', 'ν', 'σ', 'ς', 'Ῥ', 'Λ', 'Μ', 'Ν', 'Σ', 'κ', 'γ', 'χ', 'τ', 'δ', 'θ', 'π', 'β', 'φ', 'Κ', 'Γ', 'Χ', 'Τ', 'Δ', 'Θ', 'Π', 'Β', 'Φ', 'ζ', 'ψ', 'ξ', 'Ζ', 'Ψ', 'Ξ'], 'vowels': ['α', 'ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'ε', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ο', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ', 'υ', 'ὺ', 'ύ', 'ῦ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'Ὗ', 'ϋ', 'ῢ', 'ΰ', 'ῧ', 'ι', 'ὶ', 'ί', 'ῖ', 'ἰ', 'ἲ', 'ἴ', 'ἶ', 'ἱ', 'ἳ', 'ἵ', 'ἷ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἶ', 'Ἱ', 'Ἳ', 'Ἵ', 'Ἷ', 'ϊ', 'ῒ', 'ΐ', 'ῗ'], 'semivowels': ['ῥ', 'ρ', 'λ', 'μ', 'ν', 'σ', 'ς', 'Ῥ', 'Λ', 'Μ', 'Ν', 'Σ'], 'plosives': ['κ', 'γ', 'χ', 'τ', 'δ', 'θ', 'π', 'β', 'φ', 'Κ', 'Γ', 'Χ', 'Τ', 'Δ', 'Θ', 'Π', 'Β', 'Φ'], 'voiced_plosives': ['γ', 'δ', 'β', 'Γ', 'Δ', 'Β'], 'voiceless_plosives': ['κ', 'τ', 'π', 'Κ', 'Τ', 'Π'], 'aspirated_plosives': ['χ', 'θ', 'φ', 'Χ', 'Θ', 'Φ'], 'nasals': ['μ', 'ν', 'Μ', 'Ν'], 'liquids': ['ῥ', 'ρ', 'Ῥ', 'λ', 'Λ'], 'consonants': ['ῥ', 'ρ', 'λ', 'μ', 'ν', 'σ', 'ς', 'Ῥ', 'Λ', 'Μ', 'Ν', 'Σ', 'κ', 'γ', 'χ', 'τ', 'δ', 'θ', 'π', 'β', 'φ', 'Κ', 'Γ', 'Χ', 'Τ', 'Δ', 'Θ', 'Π', 'Β', 'Φ', 'ζ', 'ψ', 'ξ', 'Ζ', 'Ψ', 'Ξ'], 'double_consonants': ['ζ', 'ψ', 'ξ', 'Ζ', 'Ψ', 'Ξ'], 'alpha': ['α', 'ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ'], 'eta': ['η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ'], 'omega': ['ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ'], 'epsilon': ['ε', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ'], 'omikron': ['ο', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ'], 'upsilon': ['υ', 'ὺ', 'ύ', 'ῦ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'Ὗ', 'ϋ', 'ῢ', 'ΰ', 'ῧ'], 'iota': ['ι', 'ὶ', 'ί', 'ῖ', 'ἰ', 'ἲ', 'ἴ', 'ἶ', 'ἱ', 'ἳ', 'ἵ', 'ἷ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἶ', 'Ἱ', 'Ἳ', 'Ἵ', 'Ἷ', 'ϊ', 'ῒ', 'ΐ', 'ῗ'], 'vowels_spiritus_and_capital': ['ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'Ὗ', 'ἰ', 'ἲ', 'ἴ', 'ἶ', 'ἱ', 'ἳ', 'ἵ', 'ἷ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἶ', 'Ἱ', 'Ἳ', 'Ἵ', 'Ἷ'], 'vowels_independent': ['ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'ηή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'Ὗ', 'ϋ', 'ῢ', 'ΰ', 'ῧ', 'ἰ', 'ἲ', 'ἴ', 'ἶ', 'ἱ', 'ἳ', 'ἵ', 'ἷ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἶ', 'Ἱ', 'Ἳ', 'Ἵ', 'Ἷ', 'ϊ', 'ῒ', 'ΐ', 'ῗ'], 'vowels_new_syllable': ['α', 'ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'ε', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ο', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'ϋ', 'ῢ', 'ΰ', 'ῧ', 'ϊ', 'ῒ', 'ΐ', 'ῗ'], 'long_vowel_potential_diphthong': ['α', 'ά', 'ὰ', 'ᾶ', 'ἀ', 'ἄ', 'ἂ', 'ἆ', 'ἁ', 'ἅ', 'ἃ', 'ἇ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἆ', 'Ἁ', 'Ἅ', 'Ἃ', 'Ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ'], 'long_vowels': ['ᾶ', 'ἆ', 'ἇ', 'ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'Ἆ', 'Ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'Η', 'Ἠ', 'Ἤ', 'Ἢ', 'Ἦ', 'Ἡ', 'Ἥ', 'Ἣ', 'Ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ', 'Ω', 'Ὠ', 'Ὤ', 'Ὢ', 'Ὦ', 'Ὡ', 'Ὥ', 'Ὣ', 'Ὧ', 'ῦ', 'ὖ', 'ὗ', 'Ὗ', 'ῧ', 'ῖ', 'ἶ', 'ἷ', 'Ἶ', 'Ἷ', 'ῗ', 'αι', 'αί', 'αὶ', 'αῖ', 'αἰ', 'αἲ', 'αἴ', 'αἶ,αἱ', 'αἵ', 'αἳ', 'αἷ', 'οι', 'οί', 'οὶ', 'οῖ', 'οἰ', 'οἲ', 'οἴ', 'οἶ', 'οἱ', 'οἵ', 'οἳ', 'οἷ', 'ει', 'εί', 'εὶ', 'εῖ', 'εἰ', 'εἲ', 'εἴ', 'εἶ', 'εἱ', 'εἵ', 'εἳ', 'εἷ', 'υι', 'υὶ', 'υῖ', 'υἰ', 'υἲ', 'υἴ', 'υἶ', 'υἵ', 'υἳ', 'υἷ', 'αυ', 'αὺ', 'αύ', 'αῦ', 'αὐ', 'αὒ', 'αὔ', 'αὖ', 'αὑ', 'αὓ', 'αὕ', 'αὗ', 'ου', 'οὺ', 'ού', 'οῦ', 'οὐ', 'οὒ', 'οὔ', 'οὖ', 'οὑ', 'οὓ', 'οὕ', 'οὗ', 'ευ', 'εὺ', 'εύ', 'εῦ', 'εὐ', 'εὒ', 'εὔ', 'εὖ', 'εὑ', 'εὓ', 'εὕ', 'εὗ', 'Αἰ', 'Αἲ', 'Αἴ', 'Αἶ', 'Αἱ', 'Αἵ', 'Αἳ', 'Αἷ', 'Οἰ', 'Οἲ', 'Οἴ', 'Οἶ', 'Οἱ', 'Οἵ', 'Οἳ', 'Οἷ', 'Εἰ', 'Εἲ', 'Εἴ', 'Εἶ', 'Εἱ', 'Εἵ', 'Εἳ', 'Εἷ', 'Υἵ', 'Υἳ', 'Υἷ', 'Αὒ', 'Αὔ', 'Αὖ', 'Αὑ', 'Αὓ', 'Αὕ', 'Αὗ', 'Οὐ', 'Οὒ', 'Οὔ', 'Οὖ', 'Οὑ', 'Οὓ', 'Οὕ', 'Οὗ', 'Εὐ', 'Εὒ', 'Εὔ', 'Εὖ', 'Εὑ', 'Εὓ', 'Εὕ', 'Εὗ'], 'long_vowels_no_diphthongs': ['ᾶ', 'ἆ', 'ἇ', 'η', 'ή', 'ὴ', 'ῆ', 'ἠ', 'ἤ', 'ἢ', 'ἦ', 'ἡ', 'ἥ', 'ἣ', 'ἧ', 'ω', 'ώ', 'ὼ', 'ῶ', 'ὠ', 'ὤ', 'ὢ', 'ὦ', 'ὡ', 'ὥ', 'ὣ', 'ὧ', 'ῦ', 'ὖ', 'ὗ', 'Ὗ', 'ῧ', 'ῖ', 'ἶ', 'ἷ', 'Ἶ', 'Ἷ', 'ῗ'], 'short_vowels': ['ε', 'έ', 'ὲ', 'ἐ', 'ἔ', 'ἒ', 'ἑ', 'ἕ', 'ἓ', 'Ε', 'Ἐ', 'Ἒ', 'Ἔ', 'Ἑ', 'Ἕ', 'Ἓ', 'ο', 'ὸ', 'ό', 'ὀ', 'ὄ', 'ὂ', 'ὁ', 'ὅ', 'ὃ', 'Ο', 'Ὀ', 'Ὂ', 'Ὄ', 'Ὃ', 'Ὅ', 'Ὃ'], 'ambiguous_vowels': ['α', 'ά', 'ὰ', 'ἀ', 'ἄ', 'ἂ', 'ἁ', 'ἅ', 'ἃ', 'Α', 'Ἀ', 'Ἄ', 'Ἂ', 'Ἁ', 'Ἅ', 'Ἃ', 'υ', 'ὺ', 'ύ', 'ὐ', 'ὒ', 'ὔ', 'ὑ', 'ὓ', 'ὕ', 'Υ', 'Ὑ', 'Ὕ', 'Ὓ', 'ϋ', 'ῢ', 'ΰ', 'ι', 'ὶ', 'ί', 'ἰ', 'ἲ', 'ἴ', 'ἱ', 'ἳ', 'ἵ', 'Ι', 'Ἰ', 'Ἲ', 'Ἴ', 'Ἱ', 'Ἳ', 'Ἵ', 'ϊ', 'ῒ', 'ΐ'], 'long_vowel_diphthongs': ['ᾳ', 'ᾴ', 'ᾲ', 'ᾷ', 'ᾀ', 'ᾄ', 'ᾂ', 'ᾆ', 'ᾁ', 'ᾅ', 'ᾃ', 'ᾇ', 'ῃ', 'ῄ', 'ῂ', 'ῇ', 'ᾐ', 'ᾔ', 'ᾒ', 'ᾖ', 'ᾑ', 'ᾕ', 'ᾓ', 'ᾗ', 'ῳ', 'ῴ', 'ῲ', 'ῷ', 'ᾠ', 'ᾤ', 'ᾢ', 'ᾦ', 'ᾡ', 'ᾥ', 'ᾣ', 'ᾧ'], 'gutturals': ['κ', 'γ', 'χ', 'ξ', 'Κ', 'Γ', 'Χ', 'Ξ'], 'dentals': ['τ', 'δ', 'θ', 'ζ', 'Τ', 'Δ', 'Θ', 'Ζ'], 'labials': ['π', 'β', 'φ', 'ψ', 'Π', 'Β', 'Φ', 'Ψ']}

#This function removes unnecessary characters from a string of Greek text
def clean_text(text):
	clean = ''
	space = False
	for token in text:
		if token in phonology.get('letters'):
			clean += token
			space = False
		elif token == '.':
			clean += '.'
			space = False
		elif token in ['·', ':']:
			clean += '·'
			space = False
		elif token == ';':
			clean += ';'
			space = False
		else:
			if space == False:
				clean += ' '
				space = True
			if space == True:
				continue
	return clean

#This function takes a string of Greek text and returns a continuous string of the letters in that text ('h' marks a clash of vowels between words)
def scriptio_continua(text):
	processed_text_lst = []
	for token in text:
		if token in phonology.get('letters'):
			processed_text_lst.append(token)
		elif token == ' ' or token == '\xa0':
			if processed_text_lst[- 1] != 'h':
				processed_text_lst.append('h')
		else:
			continue
	processed_text = ''
	for i in range(len(processed_text_lst) - 1):
		if processed_text_lst[i] == 'h':
			if [i] != len(processed_text_lst) - 1:
				if processed_text_lst[i - 1] in phonology.get('vowels') and processed_text_lst[i + 1] in phonology.get('vowels'):
					if i > 1:
						processed_text += 'h'
		else:
			processed_text += processed_text_lst[i]
	if processed_text_lst[- 1] in phonology.get('letters'):
		processed_text += processed_text_lst[- 1]
	return processed_text

#This function takes a string of Greek texts and returns a list of syllables
def syllabify(text):
	vowels = phonology.get('vowels')
	consonants = phonology.get('consonants')
	vowels_new_syllable = phonology.get('vowels_new_syllable')
	long_vowels = phonology.get('long_vowels')
	line = scriptio_continua(text)
	count = 0
	syllables = []
	for i in range(len(line)):
		if line[i] in vowels:
			if line[i] in ['Α', 'Ε', 'Ο', 'Υ']:
				continue
			elif i != len(line) - 1 and line[i + 1] == 'h':
				syllables.append(line[count:i + 1])
				count = i + 2
			elif line[i] in ['α', 'ε', 'ο', 'υ']:
				if i == len(line) - 1:
					syllables.append(line[count:i + 1])
					count = i + 1
				else:
					if line[i + 1] in vowels:
						if line[i + 1] in vowels_new_syllable:
							syllables.append(line[count:i + 1])
							count = i + 1
						else:
							continue
					elif i < len(line) - 2:
						if line[i + 1] in consonants and line[i + 2] in vowels:
							syllables.append(line[count:i + 1])
							count = i + 1
						elif line[i + 2] in consonants:
							continue
			elif line[i] in phonology.get('alpha') or line [i] in phonology.get('eta') or line[i] in phonology.get('omega') or line[i] in phonology.get('upsilon'):
				if i == len(line) - 1:
					syllables.append(line[count:i + 1])
					count = i + 1
				else:
					if line[i + 1] in vowels:
						if line[i + 1] in ['υ', 'ὺ', 'ύ', 'ῦ', 'ὐ', 'ὒ', 'ὔ', 'ὖ', 'ὑ', 'ὓ', 'ὕ', 'ὗ', 'ι']:
							continue
						else:
							syllables.append(line[count:i + 1])
							count = i + 1
					elif i < len(line) - 2:
						if line[i + 1] in consonants and line[i + 2] in vowels:
							syllables.append(line[count:i + 1])
							count = i + 1
						elif line[i + 2] in consonants:
							continue
			else:
				if i == len(line) - 1:
					syllables.append(line[count:i + 1])
					count = i + 1
				else:
					if line[i + 1] in vowels:
							syllables.append(line[count:i + 1])
							count = i + 1
					elif i < len(line) - 2:
						if line[i + 1] in consonants and line[i + 2] in vowels:
							syllables.append(line[count:i + 1])
							count = i + 1
						elif line[i + 2] in consonants:
							continue
		if line[i] in consonants:
			if i == len(line) - 1:
				syllables.append(line[count:i + 1])
				count = i + 1
			else:
				if line[i + 1] in vowels:
					continue
				if line[i + 1] in consonants:
					if i == 0:
						continue
					elif line[i - 1] in vowels:
						syllables.append(line[count:i + 1])
						count = i + 1
					else:
						continue
	return syllables

#This function takes a list of syllables and returns the number of most unvoiced and least unvoiced consonants in a sequence of 25 syllables
def voicing_a(syllables):
	most_unvoiced = 0
	least_unvoiced = 100
	for i in range(len(syllables) - 24):
		sequence = syllables[i:i+25]
		unvoiced = 0
		for syllable in sequence:
			for character in syllable:
				if character in phonology.get('voiceless_plosives') or character in phonology.get('aspirated_plosives') or character in ['σ', 'ς', 'Σ']:
					unvoiced += 1
				if character in ['ψ', 'Ψ', 'ξ', 'Ξ']:
					unvoiced += 2
		if unvoiced > most_unvoiced:
			most_unvoiced = unvoiced
		if unvoiced < least_unvoiced:
			least_unvoiced = unvoiced
		if unvoiced == 2:
			print(sequence)
	return most_unvoiced, least_unvoiced

#This function prints the sequences of 25 syllables with the desired number of unvoiced plosives
def voicing_b(syllables):
	for i in range(len(syllables) - 24):
		sequence = syllables[i:i+25]
		unvoiced = 0
		for syllable in sequence:
			for character in syllable:
				if character in phonology.get('voiceless_plosives') or character in phonology.get('aspirated_plosives') or character in ['σ', 'ς', 'Σ']:
					unvoiced += 1
				if character in ['ψ', 'Ψ', 'ξ', 'Ξ']:
					unvoiced += 2
		if unvoiced == 28: #or any desired number
			print(sequence)

#This function takes a list of syllables and returns the maximum alliteration for unvoiced and voiced plosives in a sequence of ten syllables
def alliteration_a(syllables):
	most_kappa = 0
	most_gamma = 0
	most_tau = 0
	most_delta = 0
	most_pi = 0
	most_beta = 0
	for i in range(len(syllables) - 9):
		kappa_count = 0
		gamma_count = 0
		tau_count = 0
		delta_count = 0
		pi_count = 0
		beta_count = 0
		for syllable in syllables[i:i+10]:
			for character in syllable:
				if character in ['Κ', 'κ', 'Ξ', 'ξ']:
					kappa_count += 1
				if character in ['Γ', 'γ']:
					gamma_count += 1
				if character in ['Τ', 'τ']:
					tau_count += 1
				if character in ['Δ', 'δ']:
					delta_count += 1
				if character in ['Π', 'π']:
					pi_count += 1
				if character in ['Β', 'β']:
					beta_count += 1
		if kappa_count > most_kappa:
			most_kappa = kappa_count
		if gamma_count > most_gamma:
			most_gamma = gamma_count
		if tau_count > most_tau:
			most_tau = tau_count
		if delta_count > most_delta:
			most_delta = delta_count
		if pi_count > most_pi:
			most_pi = pi_count
		if beta_count > most_beta:
			most_beta = beta_count
	return most_kappa, most_gamma, most_tau, most_delta, most_pi, most_beta

#This function prints the sequences of ten syllables with the desired number of occurrences of a specific unvoiced or voiced plosive
def alliteration_b(syllables):
	most_kappa = 0
	most_gamma = 0
	most_tau = 0
	most_delta = 0
	most_pi = 0
	most_beta = 0
	for i in range(len(syllables) - 9):
		kappa_count = 0
		gamma_count = 0
		tau_count = 0
		delta_count = 0
		pi_count = 0
		beta_count = 0
		for syllable in syllables[i:i+10]:
			for character in syllable:
				if character in ['Κ', 'κ', 'Ξ', 'ξ']:
					kappa_count += 1
				if character in ['Γ', 'γ']:
					gamma_count += 1
				if character in ['Τ', 'τ']:
					tau_count += 1
				if character in ['Δ', 'δ']:
					delta_count += 1
				if character in ['Π', 'π']:
					pi_count += 1
				if character in ['Β', 'β']:
					beta_count += 1
		if kappa_count == 5: #or any desired number
			print(syllables[i:i+10])
		if gamma_count == 5:
			print(syllables[i:i+10])
		if tau_count == 5:
			print(syllables[i:i+10])
		if delta_count == 5:
			print(syllables[i:i+10])
		if pi_count == 5:
			print(syllables[i:i+10])
		if beta_count == 5:
			print(syllables[i:i+10])
